//+------------------------------------------------------------------+
//|                                                   _middlebar.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright ""
#property link      ""


#property indicator_chart_window
//---- input parameters

extern color     color_prevmid = Magenta;
extern color     color_middle  = MediumTurquoise;

double PrevMid;
double Middle;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("Previous bar midpoint");
   
   ObjectDelete("Current bar midpoint");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

//----

    PrevMid = NormalizeDouble( (iHigh(NULL,0,1) + iLow(NULL,0,1)) * 0.5 ,Digits);  
    
    Middle  = NormalizeDouble( (iHigh(NULL,0,0) + iLow(NULL,0,0)) * 0.5 ,Digits);  

    if (ObjectFind("Previous bar midpoint") != 0)
    
      {
      
          ObjectCreate("Previous bar midpoint",OBJ_ARROW,0,Time[0],PrevMid);
          ObjectSet("Previous bar midpoint",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet("Previous bar midpoint",OBJPROP_COLOR,color_prevmid);
          
          ObjectCreate("Current bar midpoint",OBJ_ARROW,0,Time[0], Middle );
          ObjectSet("Current bar midpoint",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet("Current bar midpoint",OBJPROP_COLOR,color_middle);
      }
      
      else
      {
         ObjectMove("Previous bar midpoint",0,Time[0],PrevMid);
         
         ObjectMove("Current bar midpoint",0,Time[0], Middle );
      }

   
//----
   return(0);
  }
//+------------------------------------------------------------------+